//
//  NSHTTPURLResponse+Server.m
//  SocketServer
//
//  Created by Clemens Wagner on 06.09.15.
//  Copyright © 2015 Clemens Wagner. All rights reserved.
//

#import "NSHTTPURLResponse+Server.h"

@implementation NSHTTPURLResponse (Server)

- (NSData *)serializedResponseWithBodyData:(NSData *)inData {
    NSInteger theStatusCode = self.statusCode;
    CFHTTPMessageRef theMessage = CFHTTPMessageCreateResponse(kCFAllocatorDefault, theStatusCode, (__bridge CFStringRef)([[self class] localizedStringForStatusCode:theStatusCode]), kCFHTTPVersion1_1);
    NSDictionary *theHeaders = self.allHeaderFields;
    NSData *theResult;
    
    for(NSString *theName in theHeaders) {
        CFHTTPMessageSetHeaderFieldValue(theMessage, (__bridge CFStringRef)theName, (__bridge CFStringRef)(theHeaders[theName]));
    }
    CFHTTPMessageSetBody(theMessage, (__bridge CFDataRef)inData);
    theResult = (__bridge NSData *)CFHTTPMessageCopySerializedMessage(theMessage);
    CFRelease(theMessage);
    return theResult;

}

@end