//
//  ViewController.m
//  WebKit
//
//  Created by Clemens Wagner on 08.08.15.
//  Copyright © 2015 Clemens Wagner. All rights reserved.
//

#import "WKWebViewController.h"
#import <WebKit/WebKit.h>

@interface WKWebViewController ()

@property (weak, nonatomic) WKWebView *webView;
@property (weak, nonatomic) IBOutlet UITextField *queryField;
@property (nonatomic) BOOL loadDirect;

@end

@implementation WKWebViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    UIView *theView = self.view;
    CGRect theFrame = theView.bounds;
    WKWebViewConfiguration *theConfiguration = [self configuration];
    WKWebView *theWebView = [[WKWebView alloc] initWithFrame:theFrame configuration:theConfiguration];
    NSURL *theURL = [NSURL URLWithString:@"http://localhost:8080/"];
    NSURLRequest *theRequest = [NSURLRequest requestWithURL:theURL];
    
    theWebView.autoresizingMask = UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight;
    [theView addSubview:theWebView];
    self.webView = theWebView;
    [self loadRequest:theRequest];
}

- (WKWebViewConfiguration *)configuration {
    WKWebViewConfiguration *theConfiguration = [WKWebViewConfiguration new];
    
    theConfiguration.preferences.javaScriptEnabled = YES;
    return theConfiguration;
}

- (void)loadRequest:(NSURLRequest *)inRequest {
    [self.webView loadRequest:inRequest];
}

@end
