(function($) {
var re = /([^&=]+)=?([^&]*)/g;
var decodeRE = /\+/g;
var decode = function (str) {return decodeURIComponent( str.replace(decodeRE, " ") );};
$.parseParams = function(query) {
    var params = {}, e;
    while ( e = re.exec(query) ) {
        var k = decode( e[1] ), v = decode( e[2] );
        if (k.substring(k.length - 2) === '[]') {
            k = k.substring(0, k.length - 2);
            (params[k] || (params[k] = [])).push(v);
        }
        else params[k] = v;
    }
    return params;
};
})(jQuery);

function search(inTerm) {
	$.get('/search', { 'term': inTerm }, function(inData) {
		var theContent = $("#content");
		var theArticle = theContent.find(".prototype").clone();
		var theLinkContainer = theArticle.find("p.links")
		
		theContent.find('.article:not(.prototype)').remove();
		theArticle.removeClass('prototype');
		theArticle.find('h2').text(inData.name);
		theArticle.find('p.abstract').text(inData.abstract);
		theContent.append(theArticle);
		if(inData.references && inData.references.length > 0) {
			$.each(inData.references, function() {
				var theLink = $("<a></a>");
			
				theLink.text(this);
				theLink.attr("href", "/index.html?" + $.param({q: this}));
				theLinkContainer.append(" ");
				theLinkContainer.append(theLink);
			});
		}
		else {
			theLinkContainer.remove();
		}
		$("#search input[name='q']").val(inTerm);
	}, 'json');
};

$(function() {
	$("#search input[name='q']").autocomplete({
		source: "/autocompletion",
		minLength: 1,
		select: function(inEvent, inUI) {
			search(inUI.item.value);
		}
	}).attr('autocomplete', 'off');
});
